# Lez03.md

---

## Import modules

Il `cmi` viene valutato se non crea conflitti con il resto e crea il `cmo`

```ocaml
  module type CharPQueueAbs =
    sig
      type priority = int
      type char_queue (* questa astrae e non mostra più il contenuto *)
      val empty : char_queue
      val insert : char_queue -> int -> char -> char_queue
      val extract : char_queue -> int * char * char_queue exception QueueIsEmpty
  end;;
```

+ `mli` contiene l'interfaccia
+ `ml` contiene l'implementazione

> Tutti i file devono essere lowercase

---

## Functors (Funtori)

> è sostanzialmente una **funzione** che trasforma

Viene fatto in compilazione, quindi sono statici e non altera le performance!  
Inoltre di solito un funtore chiama un altro funtore.

> il codominio è sempre una funzione

*non so quale implementazione contiene lo `Stack`*

```ocaml
  let is_balanced str =
    let s = Stack.empty in try
      String.iter
        (fun c -> match c with
          ’(’ -> Stack.push s c
        | ’)’ -> Stack.pop s
        | _ -> ()) str;
      Stack.is_empty s
    with Stack.EmptyStackException -> false
```

> I **Funtori** vanno istanziati

---

Advent of Code


